' --== Setup Script for RPNET IE PowerToy ==--
' This script installs or uninstalls the PowerToy for IE5.5 or above
' Call as "<script> <path of script>" OR "<script> UNINSTALL"

option explicit

dim oFSO		' FileSystemObject to create folder / copy files
dim strDest		' The destination where the files are placed.
dim WshShell	' WSH Shell Object (for getting the windows dir and Registry writes)
dim strMsg		' Messages
dim oArgs		' Arguments to the script (to uninstall)
Dim sCurPath    ' Current working folder

' Get the arguments for the script
set oArgs = WScript.Arguments

' check what parameters are sent
if(oArgs.Count>0 and oArgs(0)="UNINSTALL") then
    call uninstall      ' Remove
elseif (oArgs.Count>0) then ' I assume working folder being sent
    sCurPath=oArgs(0)   ' Get current working folder
    call install        ' Install
else
    MsgBox "Please use correct install routine."
end if

' Quit the script
WScript.Quit

' To uninstall, call setup.vbs with "/u" as parameter
sub uninstall
    
    ' Confirm uninstallation to user
	strMsg = "Are you sure you want to uninstall RPNET IE PowerToy?"

	' Confirm Uninstall
	if MsgBox (strMsg, vbYesNo, "Uninstall") = vbNo then
		WScript.Quit
	end if

	' Setup File and Registry handling objects
	set oFSO = CreateObject("Scripting.FileSystemObject")
	Set WshShell = Wscript.CreateObject("Wscript.Shell")
	
	' Set target as <Windows Directory>\Web\
	strDest = WshShell.Environment("PROCESS")("WINDIR") & "\Web" & "\"

	' Delete each file that runs this
	oFSO.DeleteFile(strDest & "Download with RPNET.htm")
    oFSO.DeleteFile(strDest & "elevate.*")
    oFSO.DeleteFile(strDest & "setup.*")
    oFSO.DeleteFile(WshShell.Environment("PROCESS")("USERPROFILE") & "\Favorites\Links\Download with RPNET.*")

	' Delete each key that regiters the accessories with IE5	
	WshShell.RegDelete "HKCU\Software\Microsoft\Internet Explorer\MenuExt\Download with RPNET\"

	' Delete the uninstall option in control panel
	WshShell.RegDelete "HKLM\Software\Microsoft\Windows\CurrentVersion\Uninstall\RPNET IE PowerToy\"

	' Success
	strMsg = "RPNET IE PowerToy successfully uninstalled."
	MsgBox strMsg
	
	' Cleanup
	set oFSO = Nothing
	set WshShell = Nothing
end sub

' Installs the PowerToy
sub install

	' Detailed intro message
	strMsg = "This will install RPNET IE PowerToy. " & vbCRLF
	strMsg = strMsg & "Continue to install?"

	' Confirm user decision to install product.
	if MsgBox(strMsg, vbYesNo, "Setup") = vbNO then
		Wscript.Quit
	end if

	' Set up FileSysteObject and the WSH Shell
	set oFSO = CreateObject("Scripting.FileSystemObject")
	Set WshShell = Wscript.CreateObject("Wscript.Shell")

	' Set target as <Windows Directory>\Web\
	strDest = WshShell.Environment("PROCESS")("WINDIR") & "\Web" & "\"
	
	' If the destination path does not exist(in case the user entered a new path in the box), create the folder.
	if not oFSO.FolderExists(strDest) then
		oFSO.CreateFolder strDest
	end if

	' Copy all the .htm files to target. Assumes that all files exist and none other.
	oFSO.CopyFile sCurPath & "\*.htm", strDest
	oFSO.CopyFile sCurPath & "\*.vbs", strDest	
	oFSO.CopyFile sCurPath & "\*.cmd", strDest	

	oFSO.CopyFile sCurPath & "\*.url", WshShell.Environment("PROCESS")("USERPROFILE") & "\Favorites\Links"
	set oFSO = Nothing	' Kill FSO

	' Context: Selected Text (0x10)
	WshShell.RegWrite "HKCU\Software\Microsoft\Internet Explorer\MenuExt\Download with RPNET\", strDest & "Download with RPNET.htm", "REG_SZ"
	WshShell.RegWrite "HKCU\Software\Microsoft\Internet Explorer\MenuExt\Download with RPNET\Contexts", 16, "REG_BINARY"
		
	' Add Uninstall String to Registry
	WshShell.RegWrite "HKLM\Software\Microsoft\Windows\CurrentVersion\Uninstall\RPNET IE PowerToy\",""
	WshShell.RegWrite "HKLM\Software\Microsoft\Windows\CurrentVersion\Uninstall\RPNET IE PowerToy\DisplayName", "RPNET IE PowerToy", "REG_SZ"
	WshShell.RegWrite "HKLM\Software\Microsoft\Windows\CurrentVersion\Uninstall\RPNET IE PowerToy\UninstallString",strDest & "SETUP.cmd UNINSTALL", "REG_SZ"

	' Show success message
	strMsg = "Done! " & vbCRLF
	strMsg = strMsg & "You can use the entry in Add/Remove Programs to uninstall these tools." 
	MsgBox strMsg
	
	set WshShell = Nothing		' Kill WSH object
end sub